"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var __1 = require("..");
var constants_1 = require("./constants");
var constants_2 = require("../constants");
var subtitles_1 = tslib_1.__importDefault(require("../modules/ui/subtitles/subtitles"));
var chromecast_manager_1 = tslib_1.__importDefault(require("../modules/chromecast-manager/chromecast-manager"));
var chromecast_1 = tslib_1.__importDefault(require("../modules/ui/controls/chromecast/chromecast"));
var hls_1 = tslib_1.__importDefault(require("../adapters/hls"));
var dash_1 = tslib_1.__importDefault(require("../adapters/dash"));
__1.registerModule('subtitles', subtitles_1.default);
__1.registerModule('chromecastManager', chromecast_manager_1.default);
__1.registerModule('chromecastButton', chromecast_1.default);
__1.registerPlaybackAdapter(hls_1.default);
__1.registerPlaybackAdapter(dash_1.default);
var processProps = function (props, playerInstance) {
    var propsToMethod = {
        fillAllSpace: function (value) { return playerInstance.setFillAllSpace(value); },
        rtl: function (value) { return playerInstance.setRtl(value); },
        width: function (value) { return playerInstance.setWidth(value); },
        height: function (value) { return playerInstance.setHeight(value); },
        videoType: function (value) {
            var type = (value === 'LIVE'
                ? constants_2.MediaStreamType.HLS
                : value === 'MP4-VERTICAL'
                    ? constants_2.MediaStreamType.MP4
                    : value);
            playerInstance.setSrc({
                type: type,
                url: constants_1.DEFAULT_URLS[value],
            });
            playerInstance.setTitle(value + " format");
        },
        color: function (value) {
            return playerInstance.updateTheme({ progressColor: value, color: value });
        },
        progressBarMode: function (value) {
            if (value === constants_1.MODE_OPTIONS.REGULAR) {
                playerInstance.seekOnProgressDrag();
            }
            else if (value === 'PREVIEW') {
                playerInstance.showPreviewOnProgressDrag();
            }
        },
    };
    Object.entries(props).forEach(function (_a) {
        var propKey = _a[0], propValue = _a[1];
        propsToMethod[propKey](propValue);
    });
};
var currentStoryId;
var prevPlayerProps = {};
var rootContainer;
var player;
exports.createPlayerStory = function (storyId, playerProps) {
    if (storyId !== currentStoryId) {
        currentStoryId = storyId;
        prevPlayerProps = {};
        rootContainer = document.createElement('div');
        player = __1.create({
            preload: __1.PRELOAD_TYPES.METADATA,
            playsinline: true,
        });
        player.showLogo();
        player.attachToElement(rootContainer);
        player.setFramesMap(constants_1.DEFAUTL_CONFIG);
    }
    var updatedProps = Object.keys(playerProps).reduce(function (acc, property) {
        var newValue = playerProps[property];
        var oldValue = prevPlayerProps[property];
        if (newValue !== oldValue) {
            acc[property] = newValue;
        }
        return acc;
    }, {});
    processProps(updatedProps, player);
    prevPlayerProps = tslib_1.__assign(tslib_1.__assign({}, playerProps), updatedProps);
    return { storyContainer: rootContainer, player: player };
};
//# sourceMappingURL=createPlayerStory.js.map